apiVersion: apps/v1
kind: Deployment
metadata:
  name: cloudelligent-wordpress
  labels:
    app: cloudelligent-wordpress
spec:
  replicas: 1
  selector:
    matchLabels:
      app: cloudelligent-wordpress
      tier: frontend
  template:
    metadata:
      labels:
        app: cloudelligent-wordpress
        tier: frontend
    spec:
      containers:
      - image: quickbooks2018/devops:wordpress-R1
        imagePullPolicy: Always
        name: cloudelligent-wordpress
        env:
        - name: WORDPRESS_DATABASE_HOST
          valueFrom:
            secretKeyRef:
              name: wordpress-credentials
              key: WORDPRESS_DATABASE_HOST
        - name: WORDPRESS_DATABASE_NAME
          valueFrom:
            secretKeyRef:
              name: wordpress-credentials
              key: WORDPRESS_DATABASE_NAME
        - name: WORDPRESS_DATABASE_USER
          valueFrom:
            secretKeyRef:
              name: wordpress-credentials
              key: WORDPRESS_DATABASE_USER
        - name: WORDPRESS_DATABASE_PASSWORD
          valueFrom:
            secretKeyRef:
              name: wordpress-credentials
              key: WORDPRESS_DATABASE_PASSWORD
        ports:
        - containerPort: 8080
          name: http
        resources:
          limits:
            cpu: 500m
            memory: 1024Mi
          requests:
            cpu: 500m
            memory: 1024Mi
        volumeMounts:
        - name: wordpress-persistent-storage
          mountPath: /var/www/html
      volumes:
      - name: wordpress-persistent-storage
        persistentVolumeClaim:
          claimName: wordpress
      imagePullSecrets:
      - name: regcred
---

# We need service
apiVersion: v1
kind: Service
metadata:
  name: cloudelligent-wordpress
  labels:
    app: cloudelligent-wordpress
spec:
  ports:
    - name: http
      port: 8080
      targetPort: http
    - name: https
      port: 8443
      targetPort: http
  selector:
    app: cloudelligent-wordpress
    tier: frontend
  type: NodePort

---

# We need an ingress
apiVersion: extensions/v1beta1
kind: Ingress
metadata:
  name: cloudelligent-wordpress
  namespace: default
  annotations:
    kubernetes.io/ingress.class: alb
    alb.ingress.kubernetes.io/scheme: internet-facing
    alb.ingress.kubernetes.io/target-type: instance
    alb.ingress.kubernetes.io/actions.redirect-to-eks: >
    alb.ingress.kubernetes.io/actions.redirect-to-eks: >
        {"Type":"redirect","RedirectConfig":{"Host":"*.saqlainmushtaq.com","Path":"/","Port":"443","Protocol":"HTTPS","Query":"k=v","StatusCode":"HTTP_302"}}
    alb.ingress.kubernetes.io/listen-ports: '[{"HTTP": 80}, {"HTTPS":443}]'
    alb.ingress.kubernetes.io/actions.ssl-redirect: '{"Type": "redirect", "RedirectConfig": { "Protocol": "HTTPS", "Port": "443", "StatusCode": "HTTP_301"}}'
  labels:
    app: cloudelligent-wordpress   
spec:
  rules:
  - host: devops.saqlainmushtaq.com
    http:
      paths:
      - path: /*
        backend:
          serviceName: cloudelligent-wordpress
          servicePort: 8080
